from typing import Any, Dict, Optional

from django.contrib.sessions.backends.base import SessionBase

from django.contrib.sessions.serializers import JSONSerializer

KEY_PREFIX: str

class SessionStore(SessionBase):
    accessed: bool
    serializer: JSONSerializer
    cache_key_prefix: Any = ...
    def __init__(self, session_key: Optional[str] = ...) -> None: ...
    @property
    def cache_key(self) -> str: ...
    def load(self) -> Dict[str, str]: ...
    modified: bool = ...
    def create(self) -> None: ...
    def save(self, must_create: bool = ...) -> None: ...
    def exists(self, session_key: Optional[str]) -> bool: ...
    def delete(self, session_key: Optional[str] = ...) -> None: ...
    @classmethod
    def clear_expired(cls) -> None: ...
