from datetime import datetime
from typing import Any, Dict, Optional, Union

from django.contrib.sessions.backends.base import SessionBase

class SessionStore(SessionBase):
    accessed: bool
    serializer: Type[django.core.signing.JSONSerializer]
    def load(self) -> Dict[str, Union[datetime, str]]: ...
    modified: bool = ...
    def create(self) -> None: ...
    def save(self, must_create: bool = ...) -> None: ...
    def exists(self, session_key: Optional[str] = ...) -> bool: ...
    def delete(self, session_key: Optional[str] = ...) -> None: ...
    def cycle_key(self) -> None: ...
    @classmethod
    def clear_expired(cls) -> None: ...
