from typing import Any, Dict, List, Optional, Union

from django.core.handlers.wsgi import WSGIRequest
from django.http.response import HttpResponse
from django.views.generic import View

LANGUAGE_QUERY_PARAMETER: str

def set_language(request: WSGIRequest) -> HttpResponse: ...
def get_formats() -> Dict[str, Union[List[str], int, str]]: ...

js_catalog_template: str

def render_javascript_catalog(catalog: Optional[Any] = ..., plural: Optional[Any] = ...): ...
def null_javascript_catalog(request: Any, domain: Optional[Any] = ..., packages: Optional[Any] = ...): ...

class JavaScriptCatalog(View):
    args: Tuple
    head: Callable
    kwargs: Dict[Any, Any]
    request: WSGIRequest
    domain: str = ...
    packages: List[str] = ...
    translation: django.utils.translation.trans_real.DjangoTranslation = ...
    def get(self, request: WSGIRequest, *args: Any, **kwargs: Any) -> HttpResponse: ...
    def get_paths(self, packages: List[str]) -> List[str]: ...
    def get_plural(self) -> None: ...
    def get_catalog(self) -> Dict[str, Union[List[str], str]]: ...
    def get_context_data(self, **kwargs: Any) -> Dict[str, Optional[Dict[str, Union[List[str], int, str]]]]: ...
    def render_to_response(
        self, context: Dict[str, Optional[Dict[str, Union[List[str], int, str]]]], **response_kwargs: Any
    ) -> HttpResponse: ...

class JSONCatalog(JavaScriptCatalog):
    def render_to_response(self, context: Any, **response_kwargs: Any): ...
